//+------------------------------------------------------------------+
//|                                                  Compensator.mq4 |
//|                                                  Kontrik@mail.ru |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "  Kontrik@mai.ru"
#property link      "http://kontrik.ucoz.ru (isq: 111-506-211)"

extern double bTakeProfit   = 40;
extern double sTakeProfit   = 40;
extern double bStopLoss     = 0;
extern double sStopLoss     = 0;
extern double lot           = 0.1;
extern int Slippage     = 3;  
extern int magic        = 1919191;       
extern int VARIANT      = 1;
int koeff_next_pos[20];
double  prev_pos[20]; //  
double  long_real_prev_pos[20]; //  
double  short_real_prev_pos[20];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

#include <SignalType.mqh>

int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
{
//============================================================================================+
koeff_next_pos[0]=1;
koeff_next_pos[1]=2;
koeff_next_pos[2]=3;
koeff_next_pos[3]=5;
koeff_next_pos[4]=8;
koeff_next_pos[5]=13;
koeff_next_pos[6]=21;
koeff_next_pos[7]=43;
koeff_next_pos[8]=72;
koeff_next_pos[9]=116;
koeff_next_pos[10]=180;
koeff_next_pos[11]=290;
koeff_next_pos[12]=400;

prev_pos[0]=-40;
prev_pos[1]=-40;
prev_pos[2]=-40;
prev_pos[3]=-40;
prev_pos[4]=-40;
prev_pos[5]=-40;
prev_pos[6]=-40;
prev_pos[7]=-40;
prev_pos[8]=-40;
prev_pos[9]=-40;
prev_pos[10]=-40;
prev_pos[11]=-40;
prev_pos[12]=-40;

int get_signal = Signal(VARIANT);

//============================================================================================+

//    ( )   ( )  
 
 int long_pos = 0, short_pos = 0, i; 
 int ilflag=0, isflag=0;  
 if (OrdersTotal()>0)
   {
   for(i=0;i<OrdersTotal();i++)
     {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderComment() == StringConcatenate("Long-",i+1) && OrderMagicNumber() == magic)
       {
       long_pos++;
       long_real_prev_pos[i]=(Ask - OrderOpenPrice())/Point;
       if (long_real_prev_pos[i] < prev_pos[i])
         {
         ilflag++;
         }
       }
     if(OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderComment() == StringConcatenate("Short-",i+1) && OrderMagicNumber() == magic)
       {
       short_pos++;
       short_real_prev_pos[i]=(OrderOpenPrice() - Bid)/Point;
       if (short_real_prev_pos[i] < prev_pos[i])
         {
         isflag++;
         }
       }
     }
     if (ilflag==long_pos)  OpenLongCompensation(long_pos);
     if (isflag==short_pos) OpenShortCompensation(short_pos);
   }
//----

if (long_pos<1 && short_pos<1)
  {
  /*if (get_signal ==1  || get_signal ==3)*/ OpenLong(lot);
  /*if (get_signal ==-1 || get_signal ==4)*/ OpenShort(lot);
  }



if (long_pos==1 && get_signal ==-1) CloseLong();
if (short_pos==1 && get_signal ==1) CloseShort();
} 


//============================================================================================+
int OpenLong(double volume=0.1)
//      =volume 
{
double bProfit, bLoss;
if (bTakeProfit == 0) {bProfit = 0;}
if (bTakeProfit >0)   {bProfit=Ask+bTakeProfit*Point;}
if (bStopLoss == 0)   {bLoss = 0;}
if (bStopLoss > 0)    {bLoss=Bid-bStopLoss*Point;}
  string comment="Long-1";
  color arrow_color=Red;
  if(!OrderSend(Symbol(),OP_BUY,volume,Ask,Slippage,bLoss,
                      bProfit,comment,magic,0,arrow_color))
      {
        Print("OpenLong(),OrderSelect() -   : ",GetLastError()); 
        return(-1);
      }   
}
//============================================================================================+
int OpenShort(double volume=0.1)
//      =volume
{
double sProfit, sLoss;
if (sTakeProfit == 0) {sProfit = 0;}
if (sTakeProfit >0)   {sProfit=Bid-sTakeProfit*Point;}
if (sStopLoss == 0)   {sLoss = 0;}
if (sStopLoss > 0)    {sLoss=Ask+sStopLoss*Point;}


  string comment="Short-1";
  color arrow_color=Red;
  if(!OrderSend(Symbol(),OP_SELL,volume,Bid,Slippage,sLoss,
                      sProfit,comment,magic,0,arrow_color))
      {
        Print("OpenShort(),OrderSelect() -   : ",GetLastError()); 
        return(-1);
      }    
}
//============================================================================================+
void CloseLong()
{

   for(int i=0;i<OrdersTotal();i++)
     {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == magic)
       {
       OrderClose(OrderTicket(),OrderLots(),Bid,5,DarkGreen);
       }
     }
}
//============================================================================================+
void CloseShort()
{

   for(int i=0;i<OrdersTotal();i++)
     {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == magic)
       {
       OrderClose(OrderTicket(),OrderLots(),Bid,5,Violet);
       }
     }
}
//============================================================================================+
void OpenLongCompensation(int long_pos)
{
   double left_side =0;
   for(int i=1;i<long_pos;i++)
     {
     left_side=left_side - long_real_prev_pos[i-1]*koeff_next_pos[i-1];
     }
   int New_Point=(bTakeProfit*long_pos + left_side)/koeff_next_pos[long_pos];
   double volume=koeff_next_pos[long_pos]*lot;
double bProfit, bLoss;
if (bTakeProfit == 0) {bProfit = 0;}
if (bTakeProfit >0)   {bProfit=Ask+New_Point*Point;}
if (bStopLoss == 0)   {bLoss = 0;}
if (bStopLoss > 0)    {bLoss=Bid-bStopLoss*Point;}
   for(int j=0;j<OrdersTotal();j++)
     {
     OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == magic)
       {
       if(!OrderModify(OrderTicket(), OrderOpenPrice(), bLoss, bProfit, 0, Brown)) 
         {
        Print(OrderTicket(), " OrderSelect() - return error : ",GetLastError()); 
        return(-1);
         }
       
       }
     }
  string comment=StringConcatenate("Long-",long_pos+1);
  color arrow_color=Blue;
  if(!OrderSend(Symbol(),OP_BUY,volume,Ask,Slippage,bLoss,
                      bProfit,comment,magic,0,arrow_color))
      {
        Print("OpenLong(),OrderSelect() -   : ",GetLastError()); 
        return(-1);
      }   
}

//============================================================================================+

void OpenShortCompensation(int short_pos)
{
   double left_side =0;
   for(int i=1;i<short_pos;i++)
     {
     left_side=left_side - short_real_prev_pos[i-1]*koeff_next_pos[i-1];
     }
   int New_Point=(sTakeProfit*short_pos + left_side)/koeff_next_pos[short_pos];
   double volume=koeff_next_pos[short_pos]*lot;
double sProfit, sLoss;
if (sTakeProfit == 0) {sProfit = 0;}
if (sTakeProfit >0)   {sProfit=Bid-New_Point*Point;}
if (sStopLoss == 0)   {sLoss = 0;}
if (sStopLoss > 0)    {sLoss=Ask+sStopLoss*Point;}
   for(int j=0;j<OrdersTotal();j++)
     {
     OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
     if(OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == magic)
       {
       OrderModify(OrderTicket(), Ask, sLoss, sProfit, 0, Blue);
       }
     }
  string comment=StringConcatenate("Short-",short_pos+1);
  color arrow_color=Red;
  if(!OrderSend(Symbol(),OP_SELL,volume,Bid,Slippage,sLoss,
                      sProfit,comment,magic,0,arrow_color))
      {
        Print("OpenShort(),OrderSelect() -   : ",GetLastError()); 
        return(-1);
      }    
}


